local assets=
{
	Asset("ANIM", "anim/emerald.zip"),
    Asset("ATLAS", "images/inventoryimages/emerald.xml"),
    Asset("IMAGE", "images/inventoryimages/emerald.tex"),
}

local function fn(Sim)
    
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)

	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(0.4)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.7)
    inst.Light:SetColour(32/255,229/255,153/255)
	
    inst.AnimState:SetBank("cutstone")
    inst.AnimState:SetBuild("emerald")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddComponent("inspectable")
		
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 40
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "Emerald"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/emerald.xml"
	
    return inst
end

STRINGS.NAMES.EMERALD = "Emerald"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.EMERALD = {	
	"It's shining and glowing!",
	"One of the most durable materials!",
}

return Prefab( "common/inventory/emerald", fn, assets) 
