
local assets =
{
	Asset("ANIM", "anim/emerald_armor.zip"),
    Asset("ATLAS", "images/inventoryimages/emerald_armor.xml"),
--    Asset("ATLAS", "images/inventoryimages/emerald_armor.tex"),	
}

local function OnBlocked(owner) 
    owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour")
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "emerald_armor", "swap_body")
    inst:ListenForEvent("blocked", OnBlocked, owner)
	
	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(3)
    inst.Light:SetFalloff(0.5)
    inst.Light:SetIntensity(.9)
    inst.Light:SetColour(32/255,229/255,153/255)
	
	  if inst.socket_onequip then
        inst.socket_onequip(inst, owner)
    end
	
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
	inst:RemoveEventCallback("blocked", OnBlocked, owner)
	inst.Light:Enable(false)
	
	    if inst.socket_onunequip then
        inst.socket_onunequip(inst, owner)
    end
	
end

local function fn()
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("armor_trunkvest_winter")
    inst.AnimState:SetBuild("emerald_armor")
    inst.AnimState:PlayAnimation("anim")
    
    inst:AddTag("ruins")
	inst:AddTag("metal")
    
    inst:AddComponent("inspectable")
	
    local light = inst.entity:AddLight()
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/metalarmour"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/emerald_armor.xml"
    
	inst:AddComponent("armor")
    inst.components.armor:InitCondition(TUNING.ARMORRUINS*1.5, TUNING.ARMORRUINS_ABSORPTION)

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
--	inst.entity:AddMiniMapEntity()	
--	inst.MiniMapEntity:SetIcon( "emerald_armor.tex" )	
    
    return inst
end


STRINGS.NAMES.EMERALD_ARMOR = "Emerald armor"
STRINGS.RECIPE_DESC.EMERALD_ARMOR = "Shiny armor gives great protection."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.EMERALD_ARMOR = {	
	"I have high resistance with this armor!",
}

return Prefab( "common/inventory/emerald_armor", fn, assets) 
