
local assets =
{
	Asset("ANIM", "anim/emerald_crown.zip"),
    Asset("ATLAS", "images/inventoryimages/emerald_crown.xml"),
--   Asset("ATLAS", "images/inventoryimages/emerald_crown.tex"),	
}


	local function onfinished(inst)
    inst:Remove()
end

    local function onequip(inst, owner)

        owner.AnimState:OverrideSymbol("swap_hat", "emerald_crown", "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Show("HAT_HAIR")
        owner.AnimState:Hide("HAIR_NOHAT")
        owner.AnimState:Hide("HAIR")
		
    local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(2.25)
    inst.Light:SetFalloff(0.4)
    inst.Light:SetIntensity(.8)
    inst.Light:SetColour(32/255,229/255,153/255)

    end

    local function onunequip(inst, owner)
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAT_HAIR")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")
		inst.Light:Enable(false)

        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAIR")
        end

    end
	
local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)

	local light = inst.entity:AddLight()
    
    inst:AddTag("hat")

    anim:SetBank("featherhat")
    anim:SetBuild("emerald_crown")
	anim:PlayAnimation("anim")    
	
	inst:AddComponent("armor")
    inst.components.armor:InitCondition(TUNING.ARMOR_RUINSHAT*1.5, TUNING.ARMOR_RUINSHAT_ABSORPTION)  
        
    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/emerald_crown.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable.walkspeedmult = 0.9

    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

--	inst.entity:AddMiniMapEntity()	
--	inst.MiniMapEntity:SetIcon( "emerald_crown.tex" )	
	
    return inst
end


STRINGS.NAMES.EMERALD_CROWN = "Emerald hat"
STRINGS.RECIPE_DESC.EMERALD_CROWN = "Fancy hat gives you emerald light."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.EMERALD_CROWN = {	
	"This hat is full of magic!",
	"It's even better than minerhat.",
}

return Prefab( "common/inventory/emerald_crown", fn, assets ) 
