local assets =
{
    Asset("ANIM", "anim/emerald_sword.zip"),
   	Asset("ANIM", "anim/swap_emerald_sword.zip"),
	Asset("ATLAS", "images/inventoryimages/emerald_sword.xml"),	
--	Asset("ATLAS", "images/inventoryimages/emerald_sword.tex"),	
}

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_emerald_sword", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold") 
    inst.Light:Enable(true)

end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal")
	inst.Light:Enable(false)
end

local function fn(Sim)
     local inst = CreateEntity()
	 local trans = inst.entity:AddTransform()
	 local anim = inst.entity:AddAnimState()
	 MakeInventoryPhysics(inst)
	 
	local light = inst.entity:AddLight()
	
	 anim:SetBank("nightmaresword")
	 anim:SetBuild("emerald_sword")
	 anim:PlayAnimation("idle")
	 
    inst:AddTag("sharp")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(80)
	inst.components.weapon:SetRange(0.1)
	
	inst:AddComponent("tool")
	inst.components.tool:SetAction(ACTIONS.CHOP)

	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/emerald_sword.xml"	
    
   	inst:AddComponent("inspectable")
   	
   	inst:AddTag("irreplaceable")
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
	inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.RUINS_BAT_USES*2)
    inst.components.finiteuses:SetUses(TUNING.RUINS_BAT_USES*2)
	inst.components.finiteuses:SetConsumption(ACTIONS.CHOP, 0.5)
	
    inst.components.finiteuses:SetOnFinished( onfinished )
	
	local light = inst.entity:AddLight()
	inst.Light:SetRadius(1.2)
    inst.Light:SetFalloff(0.8)
    inst.Light:SetIntensity(.8)
    inst.Light:SetColour(32/255,229/255,153/255)		
    
    return inst
	 
end


STRINGS.NAMES.EMERALD_SWORD = "Emerald sword"
STRINGS.RECIPE_DESC.EMERALD_SWORD = "The combination of beauty and power"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.EMERALD_SWORD = {	
	"Such a mighty blade!",
	"The blade was worth the trouble.",
}

return Prefab( "common/inventory/emerald_sword", fn, assets)
