local assets = 
{
        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
	    Asset("ANIM", "anim/player_wolfgang.zip"),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
				
        Asset("ANIM", "anim/emerling_v3.zip"),
		
	    Asset("ATLAS", "images/inventoryimages/emerling.xml"),
	    Asset("IMAGE", "images/inventoryimages/emerling.tex"),			
}

local prefabs = {"emerald",}

local items = {"emerald"}

SetSharedLootTable( 'emerling',{{'emerald',   1.0},	{'emerald',   1.0},{'emerald',   1.0},{'emerald',   1.0},	{'emerald',   1.0},{'emerald',   1.0},	{'emerald',   1.0},	{'emerald',   1.0},{'emerald',   1.0},{'emerald',   1.0},{'emerald',   0.5},{'emerald',   0.5},})

local function OnNewTarget(inst, data)
    inst.SoundEmitter:PlaySound("dontstarve/wilson/use_gemstaff")  
end

local function onhit(inst)
        inst.components.follower:StopFollowing()    
    inst.SoundEmitter:PlaySound("dontstarve/wilson/use_gemstaff")
end

local function ondeath(inst)
	local player = GetPlayer()
	if player then
        inst.SoundEmitter:PlaySound("dontstarve/common/destroy_stone")
		local pt = inst:GetPosition()
		inst.Light:Enable(false)   -- green light goes off when he's death
	end
end

local function KeepTarget(isnt, target)
    return target and target:IsValid()
end

local function KeepTarget(isnt, target)
    return target and target:IsValid()
end

local function entitydeathfn(inst, data)
    if data.inst:HasTag("player") then
        inst:DoTaskInTime(math.random(), function() inst.components.health:Kill() end)
        inst.SoundEmitter:PlaySound("dontstarve/wilson/rock_break")
        inst.SoundEmitter:KillSound("idle")
		local pt = inst:GetPosition()
    end
end

local function ShouldAcceptItem(inst, item)
	if (item.prefab == "emerald") then     -- He will accept emeralds, as a food.
        	return true
			end
	    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY) and not item.components.projectile then
		if item.prefab == "telestaff" then
			print ("refusing telestaff")
			return false
		end		
		    return true
    end
end

local function OnGetItemFromPlayer(inst, giver, item)

           	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY)   then     
		local newslot = item.components.equippable.equipslot
		local current = inst.components.inventory:GetEquippedItem(newslot)
		if current then
            		inst.components.inventory:DropItem(current)
        	end      
        	inst.components.inventory:Equip(item)
			
	    elseif (item.prefab == "emerald") then -- what happens, when he eat emerald
		
        inst.components.health:DoDelta(150) 
	inst.AnimState:PlayAnimation("eat")
        inst.SoundEmitter:PlaySound("dontstarve/characters/wolfgang/grow_medtolrg") 
        inst.components.follower:SetLeader(giver)
			inst.components.talker:Say("+150 HP")
    end
end

local function OnRefuseItem(inst, item)
    local playerprefab = GetPlayer()
    if playerprefab then
		inst.components.talker:Say("I don't like it!")
        inst.SoundEmitter:PlaySound("dontstarve/characters/wolfgang/shrink_lrgtomed") 		
    end
end


local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()	
	local whoisplayer = GetPlayer()	
	---------------------				
	inst.Transform:SetFourFaced(inst)
	shadow:SetSize( 1.5, .75 ) 
    MakeCharacterPhysics(inst, 75, .5)
	---------------------			
	anim:SetBank("wilson")
	anim:SetBuild("emerling_v3")
	---------------------	
    inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal") 
	---------------------	
	inst:AddComponent("locomotor")
    inst.components.locomotor:SetSlowMultiplier(1)
	inst.components.locomotor.triggerscreep = true      -- He will wake up spiders by stepping on the web.
    inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED*0.8  -- he's a little bit slower
	---------------------	
	inst:AddTag("emerald_guardian")
    inst:AddTag("character")
    inst:AddTag("largecreature")
	inst:AddTag("scarytoprey")
    inst:AddTag("notraptrigger")  -- he won't trigger your traps.
	---------------------	
    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetKeepTargetFunction(KeepTarget)
    inst.components.combat:SetAttackPeriod(1.0)     -- 1.0 because we don't won't to stun lock enemies.
    inst.components.combat:SetDefaultDamage(15)     -- He's damage unarmed.
    inst.components.combat:SetRange(1, 35)  -- range of attack. Using animation (pickaxe_loop) for attack, he can't hit moving enemies when range is less than 1,2.	
    inst.components.combat.panic_thresh = TUNING.BUNNYMAN_PANIC_THRESH
	---------------------	
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(900)
    inst.components.health.nofadeout = false  -- he will disappear after death.
    inst:ListenForEvent("death", ondeath)	
	inst.components.health.fire_damage_scale = 0  -- he's immune to fire.
	inst.components.health.canmurder = true -- you can kill him
	inst.components.health.canheal = false -- You can heal him only using emeralds!
	---------------------	
    inst:AddComponent("inspectable")  -- player can examine him.
	---------------------	
    inst:AddComponent("inventory")
	---------------------	
    inst:AddComponent("lootdropper")  -- he gives 10 emeralds as a loot after death
	inst.components.lootdropper:SetChanceLootTable('emerling')
    inst:AddComponent("norecipelootdrop")	
	---------------------	
    local minimap = inst.entity:AddMiniMapEntity()  -- adding minimap icon option
    minimap:SetIcon( "emerling.tex" )             -- map icon.
	---------------------	
    inst.items = items
    inst:ListenForEvent("entity_death", function(world, data) entitydeathfn(inst, data) end, GetWorld())
	---------------------	
    inst:AddComponent("follower")
    whoisplayer.components.leader:AddFollower(inst)	  -- he will follow player, when you create guardian.
    inst.components.follower.maxfollowtime = 99999999
    inst.components.follower:AddLoyaltyTime(9999999)	
	---------------------	
    inst:AddComponent("eater")
	---------------------	
	local brain = require"brains/emerlingbrain"
	inst:SetBrain(brain)
	inst:SetStateGraph("SGemerling")
	---------------------	
    inst:AddComponent("trader")                            -- he can take items.
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
	---------------------	
    inst:AddComponent("talker")                             -- he can speak
    inst.components.talker.fontsize = 35
    inst.components.talker.colour = Vector3(115/255, 200/255, 115/255) -- He's strings are green
    inst.components.talker:StopIgnoringAll()
	---------------------	
    inst.Transform:SetScale(1.5, 1.5, 1.5) -- he's much bigger than Wilson.
	---------------------		
	local light = inst.entity:AddLight() -- He has green light when he's alive
    inst.Light:Enable(true)
	inst.Light:SetRadius(1.3)
    inst.Light:SetFalloff(0.8)
    inst.Light:SetIntensity(.8)
    inst.Light:SetColour(32/255,229/255,153/255)
	
	return inst
end

return Prefab("common/emerling", fn, assets, prefabs)