local rock_emerald_assets =
{
	Asset("ANIM", "anim/rock_emerald.zip"),
	Asset("IMAGE", "images/inventoryimages/emerald.tex"),
	Asset("SOUND", "sound/common.fsb"),
}

local prefabs =
{
    "emerald",
	"rocks",
	"imp",
}    


SetSharedLootTable( 'rock_emerald',
{
	{'rocks',   1.0},
	{'rocks',   1.0},	
	{'rocks',   1.0},
	
    {'emerald',   1.0},
    {'emerald',   1.0},
    {'emerald',   1.0},
    {'emerald',   1.0},
    {'emerald',   1.0},	
    {'emerald',   1.0},
	
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},
	{'imp',   1.0},	
	
	{'imp',   0.2},
	{'imp',   0.2},
	{'imp',   0.2},
	{'imp',   0.2},	
	{'imp',   0.2},
	{'imp',   0.2},	
})

local function baserock_fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(1.5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.8)
    inst.Light:SetColour(32/255,229/255,153/255)
	
	MakeObstaclePhysics(inst, 1.)
	
	local minimap = inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "emerald.tex" )	

	inst:AddComponent("lootdropper") 
	
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.MINE)
	inst.components.workable:SetWorkLeft(18)
	
	inst.components.workable:SetOnWorkCallback(
		function(inst, worker, workleft)
			local pt = Point(inst.Transform:GetWorldPosition())
			if workleft <= 0 then
				inst.SoundEmitter:PlaySound("dontstarve/creatures/krampus/growllong")
				inst.components.lootdropper:DropLoot(pt)
				inst:Remove()
			else
				
				
				if workleft < TUNING.ROCKS_MINE*(2/6) then
					inst.AnimState:PlayAnimation("low")
				elseif workleft < TUNING.ROCKS_MINE*(5.5/6) then
					inst.AnimState:PlayAnimation("med")
				else
					inst.AnimState:PlayAnimation("full")
				end
			end
		end)     
  

	inst:AddComponent("inspectable")
	inst.components.inspectable.nameoverride = "EMERALD"
	MakeSnowCovered(inst, .01)        
	return inst
end

local function rock_emerald_fn(Sim)
	local inst = baserock_fn(Sim)
	inst.AnimState:SetBank("rock2")
	inst.AnimState:SetBuild("rock_emerald")
	inst.AnimState:PlayAnimation("full")

	inst.components.lootdropper:SetChanceLootTable('rock_emerald')

	return inst
end

STRINGS.NAMES.ROCK_EMERALD = "Emerald rock"

return Prefab("forest/objects/rocks/rock_emerald", rock_emerald_fn, rock_emerald_assets, prefabs)

